<?php

  // Extract the hierarchy of collections
  // from a 'dspace1.5.2' installation.

  // Use 'list-dspace16-collections.php' instead
  // for dspace 1.6.*

  // NB Edit the line below to point at your
  // install:

$dspaceurl = "http://dcommon.bu.edu";// /xmlui/community-list

function spaces($depth) {
  $ret = "";
  for ($i=0; $i<$depth; $i++) {
    $ret .= "\t";
  }
  return $ret;
}

function trimhandle($h) {
  $pos = strpos($h, "handle/");
  return substr($h, $pos + 7);
}

function getCommunities() {
  global $dspaceurl;

  $clurl = $dspaceurl."/xmlui/community-list";

  $txt = file_get_contents($clurl);
  
  $pos1 = strpos($txt, "<div id=\"content\"");
  $pos2 = strpos($txt, "<div id=\"nav\"");
  $txt = substr($txt, $pos1, $pos2-$pos1);

  $lines = explode("\n", $txt);

  $depth = 0;
  $incomm = 0;
  foreach ($lines as $line) {
    if ($incomm) {
      if (strpos($line, "</span>") !== false) {
	$incomm = 0;
      }
      else if (strpos($line, "<a href")!==false) {
	$pos1 = strpos($line, "href=\"");
	
	$pos2 = strpos($line, "\"", $pos1+6);

	$pos3 = strpos($line, "\">", $pos1+6);
	$pos4 = strpos($line, "</a>");

	$commname = substr($line, $pos3+2, $pos4-$pos3-2);
	$commhandle = trimhandle(substr($line, $pos1+6, $pos2-$pos1-6));
	print spaces($depth)."$commname\t$commhandle\n";
      }
    }
    else {
      if (strpos($line, "<ul")!==false) {
	$depth ++;
      }
      if (strpos($line, "</ul>")!==false) {
	$depth --;
      }
      if (strpos($line, "<a ") !==false) {
	// A collection
	$pos2 = strpos($line, "</a>");
	$pos1 = strpos($line, ">");
	$pos3 = strpos($line, "href=\"");
	$pos4 = strpos($line, "\"", $pos3+6);
	$collname = substr($line, $pos1+1, $pos2-$pos1-1);
	$collhandle = trimhandle(substr($line, $pos3+6, $pos4-$pos3-6));
	print spaces($depth)."$collname\t$collhandle\tcollection\n";
	
      }
      if (strpos($line, "<span class=\"bold\"") !==false) {
	$incomm = 1;
      }
    }
  }
  
}

getCommunities();

?>