<?php
require_once("config.inc.php");

// Fetch the list of communities from the 
// dspaceurl in config,inc - e.g.:
// $dspaceurl = "http://192.168.0.22:8080";
// $dspaceurl = "http://dcommon.bu.edu";// /xmlui/community-list

//
// Save the output of running this as 'communities.txt'
// and store in {publist}/php/communities.txt
//

function spaces($depth) {
  $ret = "";
  for ($i=0; $i<$depth; $i++) {
    $ret .= "\t";
  }
  return $ret;
}

function trimhandle($h) {
  $pos = strpos($h, "handle/");
  return substr($h, $pos + 7);
}

function getCommunities() {
  global $dspaceurl;

  $clurl = $dspaceurl."/xmlui/community-list";

  $txt = file_get_contents($clurl);
  
  $lines = explode("\n", $txt);

  $depth = 0;
  $incomm = 0;
  foreach ($lines as $line) {
    if ($incomm) {
      if (strpos($line, "</span>") !== false) {
	$incomm = 0;
      }
      else if (strpos($line, "<a href")!==false) {
	$pos1 = strpos($line, "href=\"");
	
	$pos2 = strpos($line, "\">");

	$pos3 = strpos($line, "</a>");

	$commname = substr($line, $pos2+2, $pos3-$pos2-2);
	$commhandle = trimhandle(substr($line, $pos1+6, $pos2-$pos1-6));
	print spaces($depth)."$commname\t$commhandle\n";
      }
    }
    else {
      if (strpos($line, "<ul>")!==false) {
	$depth ++;
      }
      if (strpos($line, "</ul>")!==false) {
	$depth --;
      }
      if (strpos($line, "<a xmlns:oreatom") !==false) {
	// A collection
	$pos2 = strpos($line, "</a>");
	$pos1 = strpos($line, ">");
	$pos3 = strpos($line, "href=\"");
	$pos4 = strpos($line, "\">");
	$collname = substr($line, $pos1+1, $pos2-$pos1-1);
	$collhandle = trimhandle(substr($line, $pos3+6, $pos4-$pos3-6));
	print spaces($depth)."$collname\t$collhandle\tcollection\n";
	
      }
      if (strpos($line, "<span xmlns:oreatom") !==false) {
	$incomm = 1;
      }
    }
  }
}

getCommunities();

?>